<?php

/**
 * PluginFileDirectoryTable
 * 
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class PluginFileDirectoryTable extends opAccessControlDoctrineTable
{
  private static $types = array(
    'private'   => 'private',
    'community' => 'community',
    'public'    => 'public'
  );

  /**
   * Returns an instance of this class.
   *
   * @return object PluginFileDirectoryTable
   */
  public static function getInstance()
  {
    return Doctrine_Core::getTable('PluginFileDirectory');
  }

  public function getMemberDirectoryListPager($memberId, $type = array(), $page = null)
  {
    $q = FileDirectoryQuery::getListQueryByMemberId($memberId, $type);

    $size = sfConfig::get('app_directory_list_max_size', 10);

    return $this->getPager($q, $size, $page);
  }

  public function getCommunityDirectoryListPager($communityId, $size = null, $page = null)
  {
    $q = FileDirectoryQuery::getListQueryByCommunityId($communityId);

    if (!$size)
    {
      $size = sfConfig::get('app_directory_list_max_size', 10);
    }

    return $this->getPager($q, $size, $page);
  }

  private function getPager(Doctrine_Query $q, $size, $page = null)
  {
    $pager = new sfDoctrinePager('FileDirectory', $size);
    $pager->setQuery($q);
    $pager->setPage($page, 1);

    return $pager;
  }

  public function appendRoles(Zend_Acl $acl)
  {
    return $acl
      ->addRole(new Zend_Acl_Role('reject'))
      ->addRole(new Zend_Acl_Role('everyone'))
      ->addRole(new Zend_Acl_Role('member'), 'everyone')
      ->addRole(new Zend_Acl_Role('author'), 'member')
      ->addRole(new Zend_Acl_Role('admin'), 'author');
  }

  public function appendRules(Zend_Acl $acl, $resource = null)
  {
    $acl->allow('admin', $resource, 'view');
    $acl->allow('admin', $resource, 'upload');
    $acl->allow('admin', $resource, 'edit');
    $acl->allow('admin', $resource, 'delete');

    if ($resource && 'public' === $resource->getType())
    {
      $acl->allow('everyone', $resource, 'view');
      if ('everyone' === opFileManageConfig::get('public_directory_edit_setting'))
      {
        $acl->allow('everyone', $resource, 'edit');
      }
      if ('everyone' === opFileManageConfig::get('public_directory_upload_setting'))
      {
        $acl->allow('everyone', $resource, 'upload');
      }
    }

    if ($resource && 'community' === $resource->getType())
    {
      # all community member can view file
      $acl->allow('member', $resource, 'view');

      $community = $resource->getConfig()->getCommunity();

      if ('public' === $community->getConfig('directory_authority'))
      {
        $acl->allow('author', $resource, 'edit');
        $acl->allow('author', $resource, 'delete');
      }

      if ('public' === $community->getConfig('file_public_flag'))
      {
        $acl->allow('everyone', $resource, 'view');
      }

      if ('public' === $community->getConfig('file_authority'))
      {
        $acl->allow('member', $resource, 'upload');
      }
    }

    return $acl;
  }

  public function getTypes()
  {
    $types = self::$types;
    if (!opFileManageConfig::isUsePrivate())
    {
      unset($types['private']);
    }
    if (!opFileManageConfig::isUseCommunity())
    {
      unset($types['community']);
    }

    return $types;
  }
}
